//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  C'0,187,0'
#property indicator_color2  C'187,0,0'
#property indicator_color3  C'187,0,0'
#property indicator_color4  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int    Length1       = 5;
extern int    Length2       = 20;
extern int    VPCIAvgLength = 16;
extern int    Price         = PRICE_CLOSE;

double vpci[];
double vpcida[];
double vpcidb[];
double vpca[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,vpci);
   SetIndexBuffer(1,vpcida);
   SetIndexBuffer(2,vpcidb);
   SetIndexBuffer(3,vpca);
   SetIndexBuffer(4,trend);

   return(0);
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _price  0
#define _pricel 1
#define _volume 2
#define _volprc 3

int start() 
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         int maxl = MathMax(Length1,Length2);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
         //
         //
         //
         //
         //
         
   if (trend[limit]==-1) CleanPoint(limit,vpcida,vpcidb);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_price]  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      work[r][_pricel] = Low[i];
      work[r][_volume] = Volume[i];
      work[r][_volprc] = Volume[i]*work[r][_price];
      
      double sumv1=0, sumvp1=0, sumv2=0, sumvp2=0, avgp=0, avgl=0;
      for (int k=0; k<maxl; k++)
      {
         if (k<Length1)
         {
            sumv1  += work[r-k][_volume];
            sumvp1 += work[r-k][_volprc];
            avgl   += work[r-k][_pricel];
         }
         if (k<Length2)
         {
            sumv2  += work[r-k][_volume];
            sumvp2 += work[r-k][_volprc];
            avgp   += work[r-k][_price];
         }
      }
      double vwma1 = 0; if (sumv1!=0) vwma1 = sumvp1 / sumv1;
      double vwma2 = 0; if (sumv2!=0) vwma2 = sumvp2 / sumv2;
      double vm    = 0; if (sumv2!=0) vm    = (sumv1 / Length1) / (sumv2/Length2);
      double vpr   = 0; if (avgl !=0) vpr   = vwma1  / (avgl/Length1);
      double vp    = vwma2 - (avgp/Length2);
    
         vpcida[i] = EMPTY_VALUE;
         vpcidb[i] = EMPTY_VALUE;
         vpci[i]   = vp*vpr*vm;
         vpca[i]   = 0;
         for (k=0; k<VPCIAvgLength; k++) vpca[i] += vpci[i+k];
                                         vpca[i] /= VPCIAvgLength;
    
         trend[i] = trend[i+1];
         if (vpci[i]>vpca[i]) trend[i] =  1;  
         if (vpci[i]<vpca[i]) trend[i] = -1;  
         if (trend[i]==-1) PlotPoint(i,vpcida,vpcidb,vpci);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}